#Телефонного справочник на основе хеш-таблицы.
#Использует метод цепочек

from linked_list import ll_insert, ll_find, ll_delete, ll_list_all

#Хеш-функция для строки имени.
    #Использует полиномиальное хеширование.
def ht_hash(name, bucket_count):
    hash_value = 0
    p = 31  
    for char in name:
        hash_value = (hash_value * p + ord(char)) % bucket_count
    return hash_value

#Создаёт пустую таблицу
def ht_create(bucket_count=128):
    return [None] * bucket_count

#Добавляет запись в таблицу.
    #Вычисляет хэш, затем вставляет в нужный бакет.
def ht_insert(buckets, name, phone):
    index = ht_hash(name, len(buckets))
    buckets[index] = ll_insert(buckets[index], name, phone)

#ищет запись в таблице
def ht_find(buckets, name):
    index = ht_hash(name, len(buckets))
    return ll_find(buckets[index], name)

#удаляет запись
def ht_delete(buckets, name):
    index = ht_hash(name, len(buckets))
    buckets[index] = ll_delete(buckets[index], name)

#сортировка по имени
def ht_list_all(buckets):
    all_records = []
    for bucket_head in buckets:
        records = ll_list_all(bucket_head)
        all_records.extend(records)
    
    all_records.sort(key=lambda x: x[0])
    return all_records